
@THE AUTHOR REFERS TO THIS PROGRAM AS FOCM36.995@

/*This GAUSS code is used to generate the estimates shown in Table 1
and the data used for Figures 1-3 (see JF96PGM3.MD).  NOTE:  This program
should not be ran without first running JF96PGM1.MD (results from that
program are used in this one).  To see how the output from this program is
is used to generate Figures 1-3, see JF96PGM3.MD.
See line 276 as the place to impose specific inflation targets as in
Figure 4.*/

new;
#lineson;
/*
library maxlik;
#include maxlik.ext;
maxset;
*/

library optmum;
#include optmum.ext;
optset;

/*
library co;
#include co.ext;
coset;
_co_Algorithm= 1;
*/

output file=c:\review\mjd_jf96\data\foco37.995 reset;
?"h:\fomc\foco36.995 from h:\fomc\focm36.995";
?" write out full model";
load dat[107,9]=c:\review\mjd_jf96\data\fomc995.txt;
@ date cpi res base m1 m2 ff tb3 tbond10 @
t=107;
ff= ln((1+dat[6:t-3,7]/100)./(1+dat[5:t-4,7]/100));
pilag= ln(dat[5:t-4,2]./dat[1:t-8,2]);
y= ff[1:rows(ff)];
ylev= dat[6:t-3,7];
ngp= ln(dat[6:t-3,2]/100);
spr= ln((1+dat[6:t-3,9]/100)./(1+dat[6:t-3,8]/100));
inf= (ln(dat[6:t-3,2]/100)-ln(dat[2:t-7,2]/100));
load da2[99,4]=c:\review\mjd_jf96\data\velfo9j.995;
forc= (da2[.,2]-da2[.,3])/100;
vola= .1*ln(da2[.,4]/(sumc(da2[.,4])/99));
@ vola= .1*da2[.,4]; @

 qtr_idx= dat[6:t-3,1];
t=rows(y); v0=1;

sigm= (100*y-sumc(100*y)/rows(y))'(100*y-sumc(100*y)/
        rows(y))/(rows(y)-1);

param=         6.46  |
               2.5798454  |
              0.375035602  |
           .290930  |
              0.13081132  |
               2.8011125  |
              0.95178  |
              0.9765423  |
              .9479| .93 |
               0.98  |
              0.9458002  |
              .15         |
              0.387999
            ;
u=.999;

param=    7.1199   |
   2.7228          |
  0.1685          |
   6.1440          |
  0.9350          |
  0.931014          |
  0.96343          |
  0.93296          |
  .05;
param=    6.3292   |
   3.2243          |
  0.18770          |
   6.6228          |
  0.94252          |
  0.95106          |
  0.93759          |
  0.88416          |
4.8850E-05         ;

param2= tran_inv(param);

vari= y~ngp~spr~pilag~forc~vola;
e0= 100*ln((1+dat[5,9]/100)./(1+dat[5,8]/100));
prl0=100*ln(dat[5,2]/100);
y0= 100*ln((1+dat[5,7]/100)/(1+dat[4,7]));
inf0=100*pilag[1];
dy= 100*ln((1+dat[6,7]/100)./(1+dat[5,7]/100));
vari=100*vari[1:rows(y),.]; indic=1|2|3|4|5;
  t=rows(vari);

Cmat= (0|0|1|zeros(15,1))'|
      (0|0|-1|zeros(15,1))'|
      (0|0|0|1|zeros(14,1))'|
      (0|0|-1|-1|zeros(14,1))'|
      (zeros(16,1)|1|0)'|
      (zeros(16,1)|-1|0)'|
      (zeros(16,1)|0|1)'|
      (zeros(16,1)|-1|-1)';
Dmat=  0|-1|0|1|0|-1|0|1;
mininf= .01;
Dmat=  mininf|-1|0|-1|mininf|-1|0|-1;
_co_C =  Cmat;
_co_D =  Dmat;

rhoglob= zeros(2,1);

@ {xout,f2,g2,retcode} = co(&q1max,TRAN_INV(param));   @
@call coprt(xout,f2,g2,retcode);  @
{xout,f2,g2,retcode} = optmum(&q1max,TRAN_INV(param));
retcode;

TRANS(xout)~g2; f2; retcode;
paramn2= xout;

      "Calculating Hessian and its inverse.....";;
      "THANK YOU FOR YOUR PATIENCE..............!!!";

hout= inv(hessp(&q1max,paramn2));
grdn_fnl=gradfd(&TRANS,paramn2);
Hsn_fnl=grdn_fnl*hout*grdn_fnl';
SD_fnl =sqrt(diag(Hsn_fnl)); @Standard errors of the estimated coefficients@

output on;
"==FINAL OUTPUT========================================================";

"likelihood value is ";; -f2;
"Estimated parameters are:";
trans(paramn2);
"var-cov matrix is:"; Hsn_fnl;
"Standard errors of parameters are:"; sd_fnl;
"===============================================================";

@procedures @

PROC (1) = q1max(param2);
local q1func,param,egap,prlgap,rho,vi,fi,ps100,ps111,ps200,ps211,lam0,lam1,
 del1,del2,lam2,sige,prs10,prs20,ps,psy,ps1,ps2,fy,llf,k,prltild,prlhat,
 etild,ehat,epstild,epshat,lfy,edrif,pra,pri,y,prl,e,vola,vgap,vf,thett,
del3,vtild,vhat,z,u,m,edr,p1,p2,p3,tp,ps300,ps311,prs30,ps3,inf,al1,al2,
p1sm,psm,ps1y,elam,ylevf,pilag,bl,m5,u5,u8,m8;

External proc trans;
 @ param=param2; @
  param = trans(param2);
  u=0.9999999999; m=0.00000000001; u5=.99; m5= .02; u8=.94; m8=.02;
/*
vari= y~ngp~spr~vola~forc; indic=1|2|3|4|5;
*/
y=vari[.,1]; prl=vari[.,2]; e=vari[.,3]; pilag=.25*vari[.,4]; vf=vari[.,5];
vola= vari[.,6];

z=ones(t,1)~vola;
inf=pilag;
ylevf=ylev;
pilag= pilag;

egap = 0; prlgap= 0; vgap=0; edrif=0|0; thett=1|1;
rho= 0;

vi= param[9];
fi= (1-2*vi);
ps100= param[5]; ps111= param[6]; ps200=.5; ps211=.5;
ps300= param[7]; ps311= param[8];
@ transition matrix @
p1= ((ps100~(1-ps111))|((1-ps100)~ps111));
p2= ((ps200~(1-ps211))|((1-ps200)~ps211));
p3= ((ps300~(1-ps311))|((1-ps300)~ps311));
tp= (p1.*.p2).*.p3;

p2= ((ps200~(1-ps211))|((1-ps200)~ps211));
tp= (p1.*.p2).*.p3;

/*
ps100= m+(u-m)/(1+exp(z[1:t,1]*param[13]));
ps111= m+(u-m)/(1+exp(z[1:t,1]*param[14]));
*/
lam0= .25*(param[1]|param[2]);
 lam1= 0|0; del1=.5|.5;
 lam2= 0|0; del2= .5|.5;

al2= 0|0;
al1= 1|1;
bl=  1|1;
sige= param[3]|param[4];  del3= 1|1; @param[18:19];@
@ unconditional transition probs. prs10,prs20 @

prs10= (1-ps111)/(2-ps100-ps111);
prs20= (1-ps211)/(2-ps200-ps211);
prs30= (1-ps311)/(2-ps300-ps311);
@ prs20= 1;@
/*
(y-pilag+prs10*lam0[1]+(1-prs10)*lam0[2]-vf);
(y-pilag-vf)~(prs10*lam0[1]+(1-prs10)*lam0[2])*ones(rows(y),1); end;
*/
@ initialize vectors @
ps1=zeros(t,2); fy=zeros(t,8);
ps=zeros(t,8); ps2=zeros(t,2); ps3=zeros(t,2); psy=zeros(t,8);
llf=zeros(t,1); prltild=zeros(t,1); prlhat= zeros(t,4);
                etild = zeros(t,1); ehat = zeros(t,2);
                epstild = zeros(t,1); epshat= zeros(t,4);
  elam=zeros(t,1);  vtild= zeros(t,1); vhat=zeros(t,2);
@ (.5) @ prlhat[1,1]= lam0[1] + del1[1]*prlgap[1] + prl0;
         prlhat[1,2]= lam0[1] + del1[2]*prlgap[1] + prl0;
         prlhat[1,3]= lam0[2] + del1[1]*prlgap[1] + prl0;
         prlhat[1,4]= lam0[2] + del1[2]*prlgap[1] + prl0;
         ehat[1,1]=   edrif[1] + del2[1]*egap[1] + e0;
         ehat[1,2]=   edrif[2] + del2[2]*egap[1] + e0;
         vhat[1,1]=   del3[1]*vgap+ v0;
         vhat[1,2]=   del3[2]*vgap+ v0;
@ (1) @ ps1[1,1:2]= prs10~(1-prs10);
        ps2[1,1:2]= prs20~(1-prs20);
        ps3[1,1:2]= prs30~(1-prs30);
        ps[1,1:8]=  (ps1[1,1:2].*.ps2[1,1:2]).*.ps3[1,1:2];
@ study column orderings: 000,001,010,011,100,101,110,111
   where elements belong to S1,S2 and S3, resp.@
@ assume pre-sample epstild are zero @
@ (2) @ epshat[1,1]= y[1]-bl[1]*(al1[1]*(pilag[1]-lam0[1])+vf[1])
                     -(1-bl[1])*al2[1]*y0
           -bl[1]*lam1[1]*.01*prlgap[1]-lam2[1]*.01*egap[1];
 epshat[1,2]= y[1]-bl[2]*(al1[2]*(pilag[1]-lam0[1])+vf[1])
                     -(1-bl[2])*al2[1]*y0
           -bl[2]*lam1[2]*.01*prlgap[1]-lam2[2]*.01*egap[1];
 epshat[1,3]= y[1]-bl[1]*(al1[1]*(pilag[1]-lam0[2])+vf[1])
                     -(1-bl[1])*al2[2]*y0
           -bl[1]*lam1[1]*.01*prlgap[1]-lam2[1]*.01*egap[1];
 epshat[1,4]= y[1]-bl[2]*(al1[2]*(pilag[1]-lam0[2])+vf[1])
                     -(1-bl[2])*al2[2]*y0
           -bl[2]*lam1[2]*.01*prlgap[1]-lam2[2]*.01*egap[1];
@ (3) @ fy[1,1]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[1,1]^2/(sige[1]*((1/vi))))));
        fy[1,3]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[1,2]^2/(sige[1]*((1/vi))))));
        fy[1,5]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[1,3]^2/(sige[1]*((1/vi))))));
        fy[1,7]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[1,4]^2/(sige[1]*((1/vi))))));
        fy[1,2]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[1,1]^2/(sige[2]*((1/vi))))));
        fy[1,4]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[1,2]^2/(sige[2]*((1/vi))))));
        fy[1,6]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[1,3]^2/(sige[2]*((1/vi))))));
        fy[1,8]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[1,4]^2/(sige[2]*((1/vi))))));
@ (4) @ psy[1,1:8]= ps[1,1:8].*fy[1,1:8]/(ps[1,1:8]*fy[1,1:8]');
@(5)@prltild[1]=(psy[1,1]+psy[1,2])*prlhat[1,1]+(psy[1,3]+psy[1,4])*prlhat[1,2]
               +(psy[1,5]+psy[1,6])*prlhat[1,3]+(psy[1,7]+psy[1,8])*prlhat[1,4];
        etild[1]=   (psy[1,1]+psy[1,2]+psy[1,5]+psy[1,6])*ehat[1,1]+(psy[1,3]
                    +psy[1,4]+psy[1,7]+psy[1,8])*ehat[1,2];
        vtild[1]=   (psy[1,1]+psy[1,3]+psy[1,5]+psy[1,7])*vhat[1,1]+(psy[1,2]
                    +psy[1,4]+psy[1,6]+psy[1,8])*vhat[1,2];
   epstild[1]= psy[1,1:8]*(epshat[1,1]~epshat[1,1]~epshat[1,2]~epshat[1,2]~
                           epshat[1,3]~epshat[1,3]~epshat[1,4]~epshat[1,4])';
        elam[1]=   (psy[1,1]+psy[1,2]+psy[1,3]+psy[1,4])*lam0[1]+(psy[1,5]
                    +psy[1,6]+psy[1,7]+psy[1,8])*lam0[2];
lfy=ln(ps[1,1:8]*fy[1,1:8]'); llf[1]= lfy;

@ now loop using the above order of operation @
k=2; do while k <= t;

@ if k >= t-8; lam0= .25*(4|4); else; lam0=.25*(param[1:2]); endif; @

@ (.5) @
         prlhat[k,1]= lam0[1]+del1[1]*(prltild[k-1]-prl[k-1]) +prl[k-1];
         prlhat[k,2]= lam0[1]+del1[2]*(prltild[k-1]-prl[k-1]) +prl[k-1];
         prlhat[k,3]= lam0[2]+del1[1]*(prltild[k-1]-prl[k-1]) +prl[k-1];
         prlhat[k,4]= lam0[2]+del1[2]*(prltild[k-1]-prl[k-1]) +prl[k-1];
         ehat[k,1]=   edrif[1] + del2[1]*(etild[k-1]-e[k-1]) + e[k-1];
         ehat[k,2]=   edrif[2] + del2[2]*(etild[k-1]-e[k-1]) + e[k-1]; @endif;@
         vhat[k,1]=  del3[1]*(vtild[k-1]-vola[k-1]) + vola[k-1];
         vhat[k,2]=  del3[2]*(vtild[k-1]-vola[k-1]) + vola[k-1];

@ study column orderings: 000,001,010,011,100,101,110,111
   where elements belong to S1,S2 and S3, resp.@

@ p2; if k == rows(z); end; endif; @

@ (1) @ ps[k,.]= (tp*psy[k-1,.]')';

@ assume pre-sample epstild are zero @
  thett[1]= 1;
  thett[2]= 1;
@ (2) @ epshat[k,1]= y[k]-bl[1]*(al1[1]*(pilag[k]-lam0[1])+vf[k])
                     -(1-bl[1])*al2[1]*y[k-1]-bl[1]*lam1[1]*.01*
       (prl[k-1]-prltild[k-1])-lam2[1]*.01*(e[k-1]-etild[k-1]);
 epshat[k,2]= y[k]-bl[2]*(al1[2]*(pilag[k]-lam0[1])+vf[k])
                     -(1-bl[2])*al2[1]*y[k-1]-bl[2]*lam1[2]*.01*
       (prl[k-1]-prltild[k-1])-lam2[2]*.01*(e[k-1]-etild[k-1]);
 epshat[k,3]= y[k]-bl[1]*(al1[1]*(pilag[k]-lam0[2])+vf[k])
                     -(1-bl[1])*al2[2]*y[k-1]-bl[1]*lam1[1]*.01*
       (prl[k-1]-prltild[k-1])-lam2[1]*.01*(e[k-1]-etild[k-1]);
 epshat[k,4]= y[k]-bl[2]*(al1[2]*(pilag[k]-lam0[2])+vf[k])
                     -(1-bl[2])*al2[2]*y[k-1]-bl[2]*lam1[2]*.01*
        (prl[k-1]-prltild[k-1])-lam2[2]*.01*(e[k-1]-etild[k-1]);
@ (3) @ fy[k,1]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[k,1]^2/(sige[1]*((1/vi))))));
       fy[k,3]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[k,2]^2/(sige[1]*((1/vi))))));
        fy[k,5]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[k,3]^2/(sige[1]*((1/vi))))));
        fy[k,7]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[1])+((1/vi)+1)*ln(1+epshat[k,4]^2/(sige[1]*((1/vi))))));
        fy[k,2]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[k,1]^2/(sige[2]*((1/vi))))));
        fy[k,4]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[k,2]^2/(sige[2]*((1/vi))))));
        fy[k,6]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[k,3]^2/(sige[2]*((1/vi))))));
        fy[k,8]=exp(lnfact(.5*((1/vi)-1))-lnfact(.5*(1/vi)-1)
                  -.5*ln((1/vi))-.5*ln(pi)-.5*
        (ln(sige[2])+((1/vi)+1)*ln(1+epshat[k,4]^2/(sige[2]*((1/vi))))));
@ (4) @ psy[k,1:8]= ps[k,1:8].*fy[k,1:8]/(ps[k,1:8]*fy[k,1:8]');
@(5)@ prltild[k]=(psy[k,1]+psy[k,2])*prlhat[k,1]+(psy[k,3]+psy[k,4])*prlhat[k,2]
          +(psy[k,5]+psy[k,6])*prlhat[k,3]+(psy[k,7]+psy[k,8])*prlhat[k,4];
        etild[k]=   (psy[k,1]+psy[k,2]+psy[k,5]+psy[k,6])*ehat[k,1]+(psy[k,3]
                    +psy[k,4]+psy[k,7]+psy[k,8])*ehat[k,2];
        vtild[k]=   (psy[k,1]+psy[k,3]+psy[k,5]+psy[k,7])*vhat[k,1]+(psy[k,2]
                    +psy[k,4]+psy[k,6]+psy[k,8])*vhat[k,2];
  epstild[k]= psy[k,1:8]*(epshat[k,1]~epshat[k,1]~epshat[k,2]~epshat[k,2]~
                          epshat[k,3]~epshat[k,3]~epshat[k,4]~epshat[k,4])';
        elam[k]=   (psy[k,1]+psy[k,2]+psy[k,3]+psy[k,4])*lam0[1]+(psy[k,5]
                    +psy[k,6]+psy[k,7]+psy[k,8])*lam0[2];
lfy=ln(ps[k,1:8]*fy[k,1:8]'); llf[k]= lfy;
 if k >= t-8; ylevf[k]=ylevf[k-1]+(y[k]-epstild[k]); endif;
k=k+1; endo;
 y~y-epstild~e~etild~prl~prltild~psy~qtr_idx; end;

/*
  rows(ylev)~rows(ylevf)~rows(elam);
@ (ylev)~(ylevf)~4*elam; end; @
@ y~y-epstild~4*elam; end;    @

/*
@SMOOTHED Prob ps100 ps111 are transition probs.@
p1sm=zeros(t,1); psm=zeros(t,1);  @ smoothed prob of S1=0@
ps1y=(psy[.,1]+psy[.,2]+psy[.,3]+psy[.,4]);
ps1 =(ps[.,1]+ps[.,2]+ps[.,3]+ps[.,4]);
  p1sm[t,.]=ps1y[t,.];
  k= t-1; do while k >= 1;
   p1sm[k]= p1sm[k+1]*ps100*ps1y[k]/ps1[k+1] +
            (1-p1sm[k+1])*(1-ps100)*ps1y[k]/(1-ps1[k+1]);

  k=k-1; endo;
/*
psm= p1sm;
  k=3; do while k <= t-3;
  psm[k]= (p1sm[k-2]+p1sm[k-1]+p1sm[k]+p1sm[k+1]+p1sm[k+2])/5;
  k= k+1; endo;
*/
psm= p1sm; psm[1:4]= .3*ones(4,1);
  k=5; do while k <= t;
  psm[k]= (p1sm[k-4]+p1sm[k-3]+p1sm[k-2]+p1sm[k-1]+p1sm[k])/5;
  k= k+1; endo;

@ (vtild-1)./(vola-1);  end; @
@ prl~prltild; end; @

y~y-epstild~e~etild~prl~prltild~psy~psm; end;
*/
*/
q1func= llf[2:t-1];
retp(sumc(-q1func));
ENDP;

@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@
PROC TRANS(coef0); @ constraining values of reg. coeff.@
   local coef1,m,u,m2,m3,m4,u2,u3,m1;
   coef1=coef0;
      u=0.9999999999; m=0.00000000001; m1=.20; u3=.985; u2=.75; m2=.9; m3=.60;
   coef1[1:4]= m+coef0[1:4]^2;
   coef1[5:6]= m3+(u3-m3)./(1+exp(coef0[5:6]));
   coef1[7:8]= m+(u-m)./(1+exp(coef0[7:8]));
@   coef1[9:10]= m2+(u3-m2)./(1+exp(coef0[9:10])); @
   coef1[9]=.5*(m+(u-m)./(1+exp(-1*coef0[9])));
@   coef1[17]= (2-.01)/pi*atan(coef0[17]);    @
@  coef1[16:17]= m1+(u-m1)./(1+exp(coef0[16:17])); @
   retp(coef1);
endp;

PROC TRAN_INV(coef0);
    local coef1,m,u,m2,m3,m4,u2,u3,m1;
    coef1=coef0;
       u=0.9999999999; m=0.00000000001;  u3=.985; m1=.20; u2=.75; m2=.9; m3=.60;
    coef1[1:4]= sqrt(coef0[1:4]-m);
    coef1[5:6]= ln((u3-coef0[7:8])./(coef0[7:8]-m3));
    coef1[7:8]= 1*ln((u3-coef0[7:8])./(coef0[7:8]-m));
@    coef1[9:10]= 1*ln((u3-coef0[9:10])./(coef0[9:10]-m2));  @
    coef1[9]=  -ln((u-m)/(2*coef0[9]-m)-1);
@   coef1[17]= tan(pi/(2-.01)*coef0[17]);                   @
    retp(coef1);
endp;
@>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>@

end;




