#THE AUTHOR REFERS TO THIS FILE AS FOMC5.BAT.

#This is an S-PLUS batch file that uses the data in foco37.995 (output
#from the second program file) and JF96DAT2.MD to generate Figures 1-3
#in the paper.  If you do not have access to S-PLUS it is at least useful
#to see how the data in the above mentioned output files are used to
#generate these graphs.


usa.o05 _ matrix(scan("c:\\data\\dueker\\af_rview\\foco35.995"),byrow=T,ncol=14)
usa.o06 _ matrix(scan("c:\\data\\dueker\\af_rview\\velfo9j.995"),byrow=T,ncol=4)
usa.o05 _ usa.o05[1:98,]
usa.o06 _ usa.o06[1:98,]
write(usa.o05, file="c:\\temp\\usa5.txt")

postscript("c:\\review\\mjd_jf96\\programs\\usa5.ps",horizontal=T)
win.graph()
mbn.ts _ ts(usa.o05[,1],start=1971.25,frequency=4)
mtildn.ts _ ts(usa.o05[,2],start=1971.25,frequency=4)
ps11n.ts _ ts(usa.o05[,7]+usa.o05[,8]+usa.o05[,9]+usa.o05[,10]
              ,start=1971.25,frequency=4)
ps31n.ts _ ts(usa.o05[,7]+usa.o05[,9]+usa.o05[,11]+usa.o05[,13]
              ,start=1971.25,frequency=4)
inf1n.ts _ ts(usa.o05[5:98,5]-usa.o05[1:94,5],start=1972.25,frequency=4)
vol.ts _ ts(usa.o06[,4],start=1971.25,frequency=4)

tsplot(inf1n.ts)
par(new=T,yaxs="d",xaxs="d")
tsplot(6.33*ps11n.ts+3.22*(1-ps11n.ts),axes=F,lty=2)
axis(side=4)
mtext("Implicit U.S. Inflation Target",side=3)
title(main="Figure 1")
par(bty="n")
legend(1983.5,11.5,c("Implicit Target","MA of actual"),lty=2:1)
dev.copy(which=2)
dev.set(which=3)
#dev.off()


win.graph()
tsplot(mbn.ts)
par(new=T,yaxs="d")
tsplot(mtildn.ts,axes=F,lty=2)
mtext("Quarterly Interest Rate Changes and Model-Implied Changes",side=3)
title(main="Figure 2")
par(bty="n")
legend(1983,4,c("Actual","Model-Implied"),lty=1:2)
dev.copy(which=2)
dev.set(which=3)
#dev.off()


win.graph()
tsplot(1-ps31n.ts)
axis(side=2)
par(new=T,xaxs="d")
tsplot(vol.ts,axes=F,lty=2)
axis(side=4)
mtext("Prob. of High-Variance Deviation from Inflation Targeting and Forecast Error Variance",side=3)
title(main="Figure 3")
par(bty="n")
corner1 <- c(1986, 1994)
corner2 <- c(6.5, 4.5)
legend(ncol=1,corner1,corner2,c("Forecast variance","Prob. of S2=1"),lty=2:1)
dev.copy(which=2)
dev.set(which=3)
#dev.off()
#dev.off()



